#include <iostream>

using namespace std;

int main()
{
    int N,Q;
    cin>>N;
    cin>>Q;
    int os=N,p,d,pot;
    int D[N],P[N],H[Q];
    for (int i=0;i<N;i++)
    {cin>>D[i];
    cin>>P[i];
    }
    for (int i=0;i<Q;i++)
        cin>>H[i];
    for (int i=0;i<Q;i++)
    { p=0;
    d=0;
        for (int j=0;j<N;j++)
        {
            if(P[j]*(os-j)>=D[j])
            {
                p=p+P[j];
                d=d+p;
            }
            else
                d=d+D[j]+p;

        }
        if(H[i]>d)
            cout<<"-1";
            else{d=0;
        p=0;
        pot=0;
        if (P[1]==0)
        {int x=0;
            while(d<H[i])
             {


                d=d+D[x];
                x++;
                pot++;
            }
        }
       
        cout<<pot;}

    }
    return 0;
}